# Mobile Transactions

## Start mobile sale transaction

> Create a mobile sale transaction using a mobile transaction token that involves authorization and capture. Transactions of $1.00 or greater are approved and automatically added to the open batch for settlement.

```json
{"openapi":"3.0.1","info":{"title":"Mobile Transactions","version":"2.0"},"paths":{"/rest/v2/mobile/transactions/sale":{"post":{"tags":["Mobile Transactions"],"summary":"Start mobile sale transaction","description":"Create a mobile sale transaction using a mobile transaction token that involves authorization and capture. Transactions of $1.00 or greater are approved and automatically added to the open batch for settlement.","operationId":"doSale","parameters":[{"name":"api-key","in":"header","description":"An access API key issued to you by Xplor Pay.","required":true},{"name":"mobilejwt","in":"header","description":"The transaction token returned from the successfulTransactionToken method of the Mobile framework.","required":true}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ClearentGatewayRequest"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ClearentGatewayRequest"}}},"required":true},"responses":{"200":{"description":"Successful Transaction","content":{"application/json":{"schema":{"$ref":"#/components/schemas/transaction"}},"application/xml":{"schema":{"$ref":"#/components/schemas/transaction"}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResult"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorResult"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResult"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorResult"}}}},"402":{"description":"Business Exception (decline, etc) ","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResult"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorResult"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResult"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorResult"}}}}}}}},"components":{"schemas":{"ClearentGatewayRequest":{"required":["amount","software-type","software-type-version","type"],"type":"object","properties":{"type":{"type":"string","description":"Type of transaction.","enum":["AUTH,SALE,FORCED SALE,REFUND (unmatched only)"]},"card":{"type":"string","description":"Credit card number."},"amount":{"type":"string","description":"Total transaction amount."},"id":{"type":"string","description":"Unique identifier for the transaction request."},"billing":{"$ref":"#/components/schemas/Address"},"shipping":{"$ref":"#/components/schemas/Address"},"csc":{"type":"string","description":"Card Security Code (CVV)."},"invoice":{"type":"string","description":"Invoice number for the transaction."},"description":{"type":"string","description":"Description of the transaction"},"comments":{"type":"string","description":"Additional comments related to the transaction."},"software-type":{"type":"string","description":"Type of software initiating the transaction."},"software-type-version":{"type":"string","description":"Version of the software used."},"sales-tax-type":{"type":"string","description":"Type of sales tax.","enum":["LOCAL_SALES_TAX,TAX_EXEMPT"]},"sales-tax-amount":{"type":"string","description":"Amount of sales tax applied."},"service-fee":{"type":"string","description":"Additional service fee."},"signature-base-64-image":{"type":"string","description":"Base64-encoded signature image."},"tip-amount":{"type":"string","description":"Tip amount included in the transaction."},"authorization-code":{"type":"string","description":"Code used to authorize the transaction."},"purchase-order":{"type":"string","description":"Purchase order number."},"email-receipt":{"type":"string","description":"Indicates if a receipt should be emailed."},"email-address":{"type":"string","description":"Email address of the customer."},"customer-id":{"type":"string","description":"Identifier for the customer."},"order-id":{"type":"string","description":"Unique identifier for the order."},"client-ip":{"type":"string","description":"IP address of the client initiating the transaction."},"billing-is-shipping":{"type":"string","description":"Indicates if billing and shipping addresses are the same."},"create-token":{"type":"string","description":"Indicates if a token should be created for future use."},"token-description":{"type":"string","description":"Description for the token if created."},"check-field":{"type":"string","description":"Field to be checked for validation."},"check-field-mid":{"type":"boolean","description":"Validates MID (Merchant ID) field."},"platform-fees":{"type":"array","description":"List of platform fees applied to the transaction.","items":{"$ref":"#/components/schemas/platform-fee"}},"card-inquiry":{"type":"boolean","description":"If true, performs a card inquiry."},"level3":{"$ref":"#/components/schemas/level3"},"secure3d":{"type":"string","description":"3D Secure authentication data."},"secure3d-eci":{"type":"string","description":"Electronic Commerce Indicator for 3D Secure."},"add-tax-to-amount":{"type":"boolean","description":"Indicates whether sales tax should be added to the total amount used for authorization and capture"}},"xml":{"name":"transaction"}},"Address":{"type":"object","properties":{"company":{"type":"string","description":"The company name for the billing address."},"street":{"type":"string","description":"The primary street address."},"street2":{"type":"string","description":"Additional street information. For example, suite."},"city":{"type":"string","description":"The billing city."},"state":{"type":"string","description":"The state of the billing address."},"zip":{"type":"string","description":"The postal code of billing address."},"country":{"type":"string","description":"The country of the billing address."},"phone":{"type":"string","description":"The contact phone number."},"first-name":{"type":"string","description":"First name of the contact."},"last-name":{"type":"string","description":"Last name of the contact."},"from-zip":{"type":"string","description":"The originating ZIP code."}},"description":"Contains billing address and contact details.","xml":{"name":"clearent-address"}},"platform-fee":{"type":"object","properties":{"fee-name":{"type":"string","description":"The name of the fee applied to the transaction.","enum":["DealManager","FillMyBook"]}},"description":"List of platform fees applied.","xml":{"name":"platform-fee"}},"level3":{"type":"object","properties":{"vat-tax-amount":{"type":"string","description":"The VAT amount applied to the transaction."},"vat-tax-rate":{"type":"string","description":"VAT tax rate applied to the transaction."},"order-date":{"type":"string","description":"The date when the order was created."},"customer-vat-registration-number":{"type":"string","description":"Cardholder's VAT registration number."},"summary-commodity-code":{"type":"string","description":"Code that identifies the type of service included in the transaction."},"discount-amount":{"type":"string","description":"Total discount amount."},"destination-country-code":{"type":"string","description":"The ISO country code of the destination."},"freight-amount":{"type":"string","description":"Freight charges."},"duty-amount":{"type":"string","description":"Duty amount applied."},"level3-items":{"$ref":"#/components/schemas/level3-items"}},"description":"Level 3 data for enhanced transaction details.","xml":{"name":"level3"}},"level3-items":{"type":"object","properties":{"level3-items":{"type":"array","items":{"$ref":"#/components/schemas/level3-item"}}},"description":"Level 3 line-item data for the transaction.","xml":{"name":"level3-items"}},"level3-item":{"type":"object","properties":{"item-description":{"type":"string","description":"Description of the item."},"item-commodity-code":{"type":"string","description":"Commodity code of the item."},"item-quantity":{"type":"string","description":"Quantity of items comprising of the order."},"item-unit-of-measure":{"type":"string","description":"The unit of measure of the purchased item as determined by ANSI X-12. Allowable Units of Measure and Codes."},"item-unit-cost":{"type":"string","description":"Per item cost for the order."},"item-product-code":{"type":"string","description":"Merchant identifiable code e.g., SKU or Model Number."},"item-tax-amount":{"type":"string","description":"Tax amount per item."},"item-tax-rate":{"type":"string","description":"Tax rate per item expressed as a decimal."},"item-discount":{"type":"string","description":"Discount amount applied per item."},"item-line-total":{"type":"string","description":"Total item count for the order."},"item-net-gross-ind":{"type":"string","description":"Indicated where the extended item amount is included in the tax. Can either be Yes (\"Y\") or No (\"N\") but should be passed as \"N\"."},"item-discount-rate":{"type":"string","description":"Discount rate applied per item expressed as a decimal."}},"description":"Level 3 line-item data for the transaction.","xml":{"name":"level3-item"}},"transaction":{"type":"object","properties":{"amount":{"type":"string","description":"Total value associated with the transaction."},"currency":{"type":"string","description":"Currency used for the transaction."},"id":{"type":"string","description":"Unique transaction ID."},"invoice":{"type":"string","description":"Invoice number associated with the transaction."},"description":{"type":"string","description":"Description of the transaction."},"comments":{"type":"string","description":"Comments associated with the transaction."},"serverId":{"type":"string","deprecated":true},"created":{"type":"string","description":"Date and time when the transaction was created."},"type":{"type":"string","description":"Identifies the transaction type.","enum":["AUTH","SALE","REFUND","VOID","CAPTURE","FORCED SALE","CARD INQUIRY"]},"result":{"type":"string","description":"Result of the transaction. For example, APPROVED.","enum":["APPROVED","DECLINED","ERROR"]},"billing":{"$ref":"#/components/schemas/Address"},"shipping":{"$ref":"#/components/schemas/Address"},"card":{"type":"string","description":"Card number used for the transaction."},"csc":{"type":"string","description":"Card Security Code used."},"cvm":{"type":"string","description":"Cardholder Verification Method used.","enum":["NON (None)","MSG(Manual Signature)","OFC(Offline Pin in the Clear)","PIN(Online Pin)","OFE(Offline Encrypted Pin)"]},"action":{"$ref":"#/components/schemas/action"},"authorization-code":{"type":"string","description":"Code indicating the transaction authorization."},"avs-result-code":{"type":"string","description":"Result code from Address Verification Service.","enum":["X","Y","A","W","Z","N","U","R","S","G"]},"avs-result-code-description":{"type":"string","description":"Description of the AVS result."},"csc-result-code":{"type":"string","description":"Result code from CSC verification.","enum":["M","N","P","S","U","X"]},"csc-result-code-description":{"type":"string","description":"Description of the CSC result."},"tip-adjusted-amount":{"type":"string","description":"Amount of the adjusted tip."},"avs-street":{"type":"string","description":"Street used in AVS check."},"avs-zip":{"type":"string","description":"ZIP code used in AVS check."},"token-description":{"type":"string","description":"Description of the token created."},"original-amount":{"type":"string","description":"Original amount before adjustments."},"tip-amount":{"type":"string","description":"Tip amount included in the transaction."},"ref-id":{"type":"string","description":"Reference ID for the transaction."},"entry-method":{"type":"string","description":"Method used to enter payment data of the transaction. For example, Swipe/Manual."},"first-recurring-transaction":{"type":"string","description":"Indicates whether this is the first recurring transaction."},"batch-string-id":{"type":"string","description":"Identifies the settlement batch ID."},"order-id":{"type":"string","description":"Order id passed in with the transaction."},"purchase-order":{"type":"string","description":"Purchase order number."},"customer-id":{"type":"string","description":"Customer id passed in with the transaction."},"email-address":{"type":"string","description":"Email address associated with the transaction."},"display-message":{"type":"string","description":"Displayable message about transaction result."},"result-code":{"type":"string","description":"Result code associated with transaction result."},"billing-is-shipping":{"type":"string","description":"Indicates if billing and shipping addresses are the same."},"tip-adjusted":{"type":"string","description":"Indicates if the tip was adjusted."},"exp-date":{"type":"string","description":"Expiration date of the card."},"client-ip":{"type":"string","description":"IP address of the client initiating the transaction."},"voided":{"type":"string","description":"Indicates if the transaction was voided."},"pending":{"type":"string","description":"Indicates if the transaction is pending."},"voided-auth":{"type":"string","description":"Indicates if the authorization was voided."},"settled":{"type":"string","description":"Indicates if the transaction has been settled."},"status":{"type":"string","description":"Status of the transaction. For example, approved."},"emv-data":{"type":"string","description":"Raw EMV data string."},"key-serial-number":{"type":"string","description":"Serial number of the encryption key used."},"emv-entry-method":{"type":"string","description":"Method used to enter EMV data.","enum":["EMV_DIP","EMV_CONTACTLESS","EMV_FALLBACK_SWIPE","EMV_FALLBACK_NONTECH"]},"software-type":{"type":"string","description":"Type of software used for the transaction."},"customer-first-name":{"type":"string","description":"First name of the customer."},"customer-last-name":{"type":"string","description":"Last name of the customer."},"plan-name":{"type":"string","description":"Name of the payment plan used."},"card-type":{"type":"string","description":"Type of card used. For example, VISA."},"contactless":{"type":"string","description":"Indicates if contactless payment was used."},"contactless-device":{"type":"string","description":"Indicates if a contactless device was used."},"sales-tax-type":{"type":"string","description":"Type of sales tax applied."},"sales-tax-amount":{"type":"string","description":"Amount of sales tax applied."},"add-tax-to-amount":{"type":"boolean","description":"Indicates if tax was added to the transaction amount."},"emv-data-response":{"type":"string","description":"Response data from EMV processing."},"emv":{"$ref":"#/components/schemas/emv"},"signature-base-64-image":{"type":"string","description":"Base64-encoded image of the signature."},"last-four":{"type":"string","description":"Last four digits of the card number."},"check-field-duplicate":{"type":"boolean","description":"Indicates if a duplicate check was performed."},"service-fee":{"type":"string","description":"Service fee applied to the transaction"},"base-amount":{"type":"string","description":"Base amount before taxes and fees."},"platform-fees":{"type":"array","description":"List of platform fees applied.","items":{"$ref":"#/components/schemas/platform-fee"}},"merchant-id":{"type":"string","description":"Identifier for the merchant."},"terminal-id":{"type":"string","description":"Identifier for the terminal used."},"surcharge-applied":{"type":"boolean","description":"Indicates if a surcharge was applied."},"level3":{"$ref":"#/components/schemas/level3"},"partial-authorization":{"type":"boolean","description":"Indicates if partial authorization was allowed."},"partial-approved":{"type":"boolean","description":"Indicates if the transaction was partially approved."},"additional-amounts":{"type":"array","description":"List of additional amounts applied to the transaction.","xml":{"wrapped":true},"items":{"$ref":"#/components/schemas/additional-amount"}},"secure3d-eci":{"type":"string","description":"Electronic Commerce Indicator for 3D Secure."},"secure3d-result-code":{"type":"string","description":"Result code from 3D Secure authentication."},"total-amount":{"type":"string","description":"Total amount including all charges."},"processing-party-reference":{"type":"string","description":"Reference ID from the processing party."},"original-processing-party-reference":{"type":"string","description":"Reference of the original transaction assigned by the processing party."},"external-transaction-reference":{"type":"string","description":"External reference ID for the transaction."},"funding-reference":{"type":"string","description":"Reference for the funding transaction."},"token-id":{"type":"string","description":"Identifier of the payment token."},"network-transaction-reference":{"type":"string","description":"Reference ID from the payment network for the transaction."},"create-token":{"type":"boolean","description":"Indicates if a token should be created for the transaction."},"moto":{"type":"boolean","description":"Indicates whether the transaction is MOTO."},"issuer_id":{"type":"string","description":"Identifier for the card issuer."},"digital-wallet-type":{"type":"string","description":"Type of digital wallet used. For example, GOOGLE."}},"description":"Contains all details related to the authorized transaction.","xml":{"name":"transaction"}},"action":{"type":"object","properties":{"url":{"type":"string","description":"URL endpoint used for the transaction."},"method":{"type":"string","description":"Method used for the transaction. For example, POST, GET."},"type":{"type":"string","description":"Type of transaction. For example, SALE."},"environment":{"type":"string","description":"Environment in which the transaction was processed. For example, production, test."},"locale":{"type":"string","description":"Locale setting used during the transaction."},"data":{"type":"object","additionalProperties":{"type":"string","description":"Additional data properties related to the action."},"description":"Additional data properties related to the action."},"payment-method-type":{"type":"string","description":"Type of payment method used. For example, card, wallet."},"sub-type":{"type":"string","description":"Sub-category of the transaction type."},"client-key":{"type":"string","description":"Key identifying the client initiating the transaction."},"qr-code-data":{"type":"string","description":"Data encoded in the QR code for the transaction."}},"description":"The transaction action performed.","xml":{"name":"action"}},"emv":{"type":"object","properties":{"application-name":{"type":"string","description":"The name of the EMV application used to process the transaction."},"application-id":{"type":"string","description":"The unique identifier of the application."},"terminal-verification-results":{"type":"string","description":"Results of terminal-level verification during the transaction."},"transaction-status-information":{"type":"string","description":"Status details that describes the processing state of the transaction."},"iad":{"type":"string","description":"IAD provided by the card issuer during the authorization."},"transaction-certificate":{"type":"string","description":"A certificate generated during the transaction processing."},"application-transaction-counter":{"type":"string","description":"A counter that increments with each transaction."}},"description":"EMV chip data related to the transaction.","xml":{"name":"emv"}},"additional-amount":{"type":"object","properties":{"amount":{"type":"string","description":"Amount of transaction."},"account-type":{"type":"string","description":"Account type of transaction."},"amount-type":{"type":"string","description":"Refers to amount type of transaction."}},"description":"List of additional amounts applied to the transaction.","xml":{"name":"additional-amount"}},"ErrorResult":{"type":"object","properties":{"errorResults":{"type":"array","items":{"$ref":"#/components/schemas/Error"}}}},"Error":{"type":"object","properties":{"errorMessage":{"type":"string","description":"Describes the reason for the error."},"resultCode":{"type":"integer","description":"Numeric code that identifies the type of error returned by the request.","format":"int32"},"timeStamp":{"type":"string","description":"Date and time when the error occurred, ISO 8601 format (UTC)."}}}}}}
```

## Refund mobile transaction

> Create the mobile refund transaction using a mobile transaction token for card-present refunds. Refund amounts must be less than or equal to the original transaction amount, and amounts of $1.00 or greater are approved during testing.

```json
{"openapi":"3.0.1","info":{"title":"Mobile Transactions","version":"2.0"},"paths":{"/rest/v2/mobile/transactions/refund":{"post":{"tags":["Mobile Transactions"],"summary":"Refund mobile transaction","description":"Create the mobile refund transaction using a mobile transaction token for card-present refunds. Refund amounts must be less than or equal to the original transaction amount, and amounts of $1.00 or greater are approved during testing.","operationId":"doRefund","parameters":[{"name":"api-key","in":"header","description":"An access API key issued to you by Xplor Pay.","required":true},{"name":"mobilejwt","in":"header","description":"The transaction token returned from the successfulTransactionToken method of the Mobile framework.","required":true}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ClearentGatewayRequest"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ClearentGatewayRequest"}}},"required":true},"responses":{"200":{"description":"Successful Transaction","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ClearentTransactionResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ClearentTransactionResponsePayload"}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResult"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorResult"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResult"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorResult"}}}},"402":{"description":"Business Exception (decline, etc.) ","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResult"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorResult"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResult"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorResult"}}}}}}}},"components":{"schemas":{"ClearentGatewayRequest":{"required":["amount","software-type","software-type-version","type"],"type":"object","properties":{"type":{"type":"string","description":"Type of transaction.","enum":["AUTH,SALE,FORCED SALE,REFUND (unmatched only)"]},"card":{"type":"string","description":"Credit card number."},"amount":{"type":"string","description":"Total transaction amount."},"id":{"type":"string","description":"Unique identifier for the transaction request."},"billing":{"$ref":"#/components/schemas/Address"},"shipping":{"$ref":"#/components/schemas/Address"},"csc":{"type":"string","description":"Card Security Code (CVV)."},"invoice":{"type":"string","description":"Invoice number for the transaction."},"description":{"type":"string","description":"Description of the transaction"},"comments":{"type":"string","description":"Additional comments related to the transaction."},"software-type":{"type":"string","description":"Type of software initiating the transaction."},"software-type-version":{"type":"string","description":"Version of the software used."},"sales-tax-type":{"type":"string","description":"Type of sales tax.","enum":["LOCAL_SALES_TAX,TAX_EXEMPT"]},"sales-tax-amount":{"type":"string","description":"Amount of sales tax applied."},"service-fee":{"type":"string","description":"Additional service fee."},"signature-base-64-image":{"type":"string","description":"Base64-encoded signature image."},"tip-amount":{"type":"string","description":"Tip amount included in the transaction."},"authorization-code":{"type":"string","description":"Code used to authorize the transaction."},"purchase-order":{"type":"string","description":"Purchase order number."},"email-receipt":{"type":"string","description":"Indicates if a receipt should be emailed."},"email-address":{"type":"string","description":"Email address of the customer."},"customer-id":{"type":"string","description":"Identifier for the customer."},"order-id":{"type":"string","description":"Unique identifier for the order."},"client-ip":{"type":"string","description":"IP address of the client initiating the transaction."},"billing-is-shipping":{"type":"string","description":"Indicates if billing and shipping addresses are the same."},"create-token":{"type":"string","description":"Indicates if a token should be created for future use."},"token-description":{"type":"string","description":"Description for the token if created."},"check-field":{"type":"string","description":"Field to be checked for validation."},"check-field-mid":{"type":"boolean","description":"Validates MID (Merchant ID) field."},"platform-fees":{"type":"array","description":"List of platform fees applied to the transaction.","items":{"$ref":"#/components/schemas/platform-fee"}},"card-inquiry":{"type":"boolean","description":"If true, performs a card inquiry."},"level3":{"$ref":"#/components/schemas/level3"},"secure3d":{"type":"string","description":"3D Secure authentication data."},"secure3d-eci":{"type":"string","description":"Electronic Commerce Indicator for 3D Secure."},"add-tax-to-amount":{"type":"boolean","description":"Indicates whether sales tax should be added to the total amount used for authorization and capture"}},"xml":{"name":"transaction"}},"Address":{"type":"object","properties":{"company":{"type":"string","description":"The company name for the billing address."},"street":{"type":"string","description":"The primary street address."},"street2":{"type":"string","description":"Additional street information. For example, suite."},"city":{"type":"string","description":"The billing city."},"state":{"type":"string","description":"The state of the billing address."},"zip":{"type":"string","description":"The postal code of billing address."},"country":{"type":"string","description":"The country of the billing address."},"phone":{"type":"string","description":"The contact phone number."},"first-name":{"type":"string","description":"First name of the contact."},"last-name":{"type":"string","description":"Last name of the contact."},"from-zip":{"type":"string","description":"The originating ZIP code."}},"description":"Contains billing address and contact details.","xml":{"name":"clearent-address"}},"platform-fee":{"type":"object","properties":{"fee-name":{"type":"string","description":"The name of the fee applied to the transaction.","enum":["DealManager","FillMyBook"]}},"description":"List of platform fees applied.","xml":{"name":"platform-fee"}},"level3":{"type":"object","properties":{"vat-tax-amount":{"type":"string","description":"The VAT amount applied to the transaction."},"vat-tax-rate":{"type":"string","description":"VAT tax rate applied to the transaction."},"order-date":{"type":"string","description":"The date when the order was created."},"customer-vat-registration-number":{"type":"string","description":"Cardholder's VAT registration number."},"summary-commodity-code":{"type":"string","description":"Code that identifies the type of service included in the transaction."},"discount-amount":{"type":"string","description":"Total discount amount."},"destination-country-code":{"type":"string","description":"The ISO country code of the destination."},"freight-amount":{"type":"string","description":"Freight charges."},"duty-amount":{"type":"string","description":"Duty amount applied."},"level3-items":{"$ref":"#/components/schemas/level3-items"}},"description":"Level 3 data for enhanced transaction details.","xml":{"name":"level3"}},"level3-items":{"type":"object","properties":{"level3-items":{"type":"array","items":{"$ref":"#/components/schemas/level3-item"}}},"description":"Level 3 line-item data for the transaction.","xml":{"name":"level3-items"}},"level3-item":{"type":"object","properties":{"item-description":{"type":"string","description":"Description of the item."},"item-commodity-code":{"type":"string","description":"Commodity code of the item."},"item-quantity":{"type":"string","description":"Quantity of items comprising of the order."},"item-unit-of-measure":{"type":"string","description":"The unit of measure of the purchased item as determined by ANSI X-12. Allowable Units of Measure and Codes."},"item-unit-cost":{"type":"string","description":"Per item cost for the order."},"item-product-code":{"type":"string","description":"Merchant identifiable code e.g., SKU or Model Number."},"item-tax-amount":{"type":"string","description":"Tax amount per item."},"item-tax-rate":{"type":"string","description":"Tax rate per item expressed as a decimal."},"item-discount":{"type":"string","description":"Discount amount applied per item."},"item-line-total":{"type":"string","description":"Total item count for the order."},"item-net-gross-ind":{"type":"string","description":"Indicated where the extended item amount is included in the tax. Can either be Yes (\"Y\") or No (\"N\") but should be passed as \"N\"."},"item-discount-rate":{"type":"string","description":"Discount rate applied per item expressed as a decimal."}},"description":"Level 3 line-item data for the transaction.","xml":{"name":"level3-item"}},"ClearentTransactionResponsePayload":{"type":"object","properties":{"transaction":{"$ref":"#/components/schemas/transaction"},"payloadType":{"type":"string","description":"Type of payload returned in the response.","xml":{"name":"type","attribute":true}}},"description":"payload","xml":{"name":"payload"}},"transaction":{"type":"object","properties":{"amount":{"type":"string","description":"Total value associated with the transaction."},"currency":{"type":"string","description":"Currency used for the transaction."},"id":{"type":"string","description":"Unique transaction ID."},"invoice":{"type":"string","description":"Invoice number associated with the transaction."},"description":{"type":"string","description":"Description of the transaction."},"comments":{"type":"string","description":"Comments associated with the transaction."},"serverId":{"type":"string","deprecated":true},"created":{"type":"string","description":"Date and time when the transaction was created."},"type":{"type":"string","description":"Identifies the transaction type.","enum":["AUTH","SALE","REFUND","VOID","CAPTURE","FORCED SALE","CARD INQUIRY"]},"result":{"type":"string","description":"Result of the transaction. For example, APPROVED.","enum":["APPROVED","DECLINED","ERROR"]},"billing":{"$ref":"#/components/schemas/Address"},"shipping":{"$ref":"#/components/schemas/Address"},"card":{"type":"string","description":"Card number used for the transaction."},"csc":{"type":"string","description":"Card Security Code used."},"cvm":{"type":"string","description":"Cardholder Verification Method used.","enum":["NON (None)","MSG(Manual Signature)","OFC(Offline Pin in the Clear)","PIN(Online Pin)","OFE(Offline Encrypted Pin)"]},"action":{"$ref":"#/components/schemas/action"},"authorization-code":{"type":"string","description":"Code indicating the transaction authorization."},"avs-result-code":{"type":"string","description":"Result code from Address Verification Service.","enum":["X","Y","A","W","Z","N","U","R","S","G"]},"avs-result-code-description":{"type":"string","description":"Description of the AVS result."},"csc-result-code":{"type":"string","description":"Result code from CSC verification.","enum":["M","N","P","S","U","X"]},"csc-result-code-description":{"type":"string","description":"Description of the CSC result."},"tip-adjusted-amount":{"type":"string","description":"Amount of the adjusted tip."},"avs-street":{"type":"string","description":"Street used in AVS check."},"avs-zip":{"type":"string","description":"ZIP code used in AVS check."},"token-description":{"type":"string","description":"Description of the token created."},"original-amount":{"type":"string","description":"Original amount before adjustments."},"tip-amount":{"type":"string","description":"Tip amount included in the transaction."},"ref-id":{"type":"string","description":"Reference ID for the transaction."},"entry-method":{"type":"string","description":"Method used to enter payment data of the transaction. For example, Swipe/Manual."},"first-recurring-transaction":{"type":"string","description":"Indicates whether this is the first recurring transaction."},"batch-string-id":{"type":"string","description":"Identifies the settlement batch ID."},"order-id":{"type":"string","description":"Order id passed in with the transaction."},"purchase-order":{"type":"string","description":"Purchase order number."},"customer-id":{"type":"string","description":"Customer id passed in with the transaction."},"email-address":{"type":"string","description":"Email address associated with the transaction."},"display-message":{"type":"string","description":"Displayable message about transaction result."},"result-code":{"type":"string","description":"Result code associated with transaction result."},"billing-is-shipping":{"type":"string","description":"Indicates if billing and shipping addresses are the same."},"tip-adjusted":{"type":"string","description":"Indicates if the tip was adjusted."},"exp-date":{"type":"string","description":"Expiration date of the card."},"client-ip":{"type":"string","description":"IP address of the client initiating the transaction."},"voided":{"type":"string","description":"Indicates if the transaction was voided."},"pending":{"type":"string","description":"Indicates if the transaction is pending."},"voided-auth":{"type":"string","description":"Indicates if the authorization was voided."},"settled":{"type":"string","description":"Indicates if the transaction has been settled."},"status":{"type":"string","description":"Status of the transaction. For example, approved."},"emv-data":{"type":"string","description":"Raw EMV data string."},"key-serial-number":{"type":"string","description":"Serial number of the encryption key used."},"emv-entry-method":{"type":"string","description":"Method used to enter EMV data.","enum":["EMV_DIP","EMV_CONTACTLESS","EMV_FALLBACK_SWIPE","EMV_FALLBACK_NONTECH"]},"software-type":{"type":"string","description":"Type of software used for the transaction."},"customer-first-name":{"type":"string","description":"First name of the customer."},"customer-last-name":{"type":"string","description":"Last name of the customer."},"plan-name":{"type":"string","description":"Name of the payment plan used."},"card-type":{"type":"string","description":"Type of card used. For example, VISA."},"contactless":{"type":"string","description":"Indicates if contactless payment was used."},"contactless-device":{"type":"string","description":"Indicates if a contactless device was used."},"sales-tax-type":{"type":"string","description":"Type of sales tax applied."},"sales-tax-amount":{"type":"string","description":"Amount of sales tax applied."},"add-tax-to-amount":{"type":"boolean","description":"Indicates if tax was added to the transaction amount."},"emv-data-response":{"type":"string","description":"Response data from EMV processing."},"emv":{"$ref":"#/components/schemas/emv"},"signature-base-64-image":{"type":"string","description":"Base64-encoded image of the signature."},"last-four":{"type":"string","description":"Last four digits of the card number."},"check-field-duplicate":{"type":"boolean","description":"Indicates if a duplicate check was performed."},"service-fee":{"type":"string","description":"Service fee applied to the transaction"},"base-amount":{"type":"string","description":"Base amount before taxes and fees."},"platform-fees":{"type":"array","description":"List of platform fees applied.","items":{"$ref":"#/components/schemas/platform-fee"}},"merchant-id":{"type":"string","description":"Identifier for the merchant."},"terminal-id":{"type":"string","description":"Identifier for the terminal used."},"surcharge-applied":{"type":"boolean","description":"Indicates if a surcharge was applied."},"level3":{"$ref":"#/components/schemas/level3"},"partial-authorization":{"type":"boolean","description":"Indicates if partial authorization was allowed."},"partial-approved":{"type":"boolean","description":"Indicates if the transaction was partially approved."},"additional-amounts":{"type":"array","description":"List of additional amounts applied to the transaction.","xml":{"wrapped":true},"items":{"$ref":"#/components/schemas/additional-amount"}},"secure3d-eci":{"type":"string","description":"Electronic Commerce Indicator for 3D Secure."},"secure3d-result-code":{"type":"string","description":"Result code from 3D Secure authentication."},"total-amount":{"type":"string","description":"Total amount including all charges."},"processing-party-reference":{"type":"string","description":"Reference ID from the processing party."},"original-processing-party-reference":{"type":"string","description":"Reference of the original transaction assigned by the processing party."},"external-transaction-reference":{"type":"string","description":"External reference ID for the transaction."},"funding-reference":{"type":"string","description":"Reference for the funding transaction."},"token-id":{"type":"string","description":"Identifier of the payment token."},"network-transaction-reference":{"type":"string","description":"Reference ID from the payment network for the transaction."},"create-token":{"type":"boolean","description":"Indicates if a token should be created for the transaction."},"moto":{"type":"boolean","description":"Indicates whether the transaction is MOTO."},"issuer_id":{"type":"string","description":"Identifier for the card issuer."},"digital-wallet-type":{"type":"string","description":"Type of digital wallet used. For example, GOOGLE."}},"description":"Contains all details related to the authorized transaction.","xml":{"name":"transaction"}},"action":{"type":"object","properties":{"url":{"type":"string","description":"URL endpoint used for the transaction."},"method":{"type":"string","description":"Method used for the transaction. For example, POST, GET."},"type":{"type":"string","description":"Type of transaction. For example, SALE."},"environment":{"type":"string","description":"Environment in which the transaction was processed. For example, production, test."},"locale":{"type":"string","description":"Locale setting used during the transaction."},"data":{"type":"object","additionalProperties":{"type":"string","description":"Additional data properties related to the action."},"description":"Additional data properties related to the action."},"payment-method-type":{"type":"string","description":"Type of payment method used. For example, card, wallet."},"sub-type":{"type":"string","description":"Sub-category of the transaction type."},"client-key":{"type":"string","description":"Key identifying the client initiating the transaction."},"qr-code-data":{"type":"string","description":"Data encoded in the QR code for the transaction."}},"description":"The transaction action performed.","xml":{"name":"action"}},"emv":{"type":"object","properties":{"application-name":{"type":"string","description":"The name of the EMV application used to process the transaction."},"application-id":{"type":"string","description":"The unique identifier of the application."},"terminal-verification-results":{"type":"string","description":"Results of terminal-level verification during the transaction."},"transaction-status-information":{"type":"string","description":"Status details that describes the processing state of the transaction."},"iad":{"type":"string","description":"IAD provided by the card issuer during the authorization."},"transaction-certificate":{"type":"string","description":"A certificate generated during the transaction processing."},"application-transaction-counter":{"type":"string","description":"A counter that increments with each transaction."}},"description":"EMV chip data related to the transaction.","xml":{"name":"emv"}},"additional-amount":{"type":"object","properties":{"amount":{"type":"string","description":"Amount of transaction."},"account-type":{"type":"string","description":"Account type of transaction."},"amount-type":{"type":"string","description":"Refers to amount type of transaction."}},"description":"List of additional amounts applied to the transaction.","xml":{"name":"additional-amount"}},"ErrorResult":{"type":"object","properties":{"errorResults":{"type":"array","items":{"$ref":"#/components/schemas/Error"}}}},"Error":{"type":"object","properties":{"errorMessage":{"type":"string","description":"Describes the reason for the error."},"resultCode":{"type":"integer","description":"Numeric code that identifies the type of error returned by the request.","format":"int32"},"timeStamp":{"type":"string","description":"Date and time when the error occurred, ISO 8601 format (UTC)."}}}}}}
```

## Start forced sale mobile transaction

> Create a mobile forced sale transaction of $1 or more using a mobile transaction token to post a transaction without prior authorization.

```json
{"openapi":"3.0.1","info":{"title":"Mobile Transactions","version":"2.0"},"paths":{"/rest/v2/mobile/transactions/forced-sale":{"post":{"tags":["Mobile Transactions"],"summary":"Start forced sale mobile transaction","description":"Create a mobile forced sale transaction of $1 or more using a mobile transaction token to post a transaction without prior authorization.","operationId":"doForcedSale","parameters":[{"name":"api-key","in":"header","description":"An access API key issued to you by Xplor Pay.","required":true},{"name":"mobilejwt","in":"header","description":"The transaction token returned from the successfulTransactionToken method of the Mobile framework.","required":true}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ClearentGatewayRequest"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ClearentGatewayRequest"}}},"required":true},"responses":{"200":{"description":"Successful Transaction","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ClearentTransactionResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ClearentTransactionResponsePayload"}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResult"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorResult"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResult"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorResult"}}}},"402":{"description":"Business Exception (decline, etc.) ","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResult"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorResult"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResult"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorResult"}}}}}}}},"components":{"schemas":{"ClearentGatewayRequest":{"required":["amount","software-type","software-type-version","type"],"type":"object","properties":{"type":{"type":"string","description":"Type of transaction.","enum":["AUTH,SALE,FORCED SALE,REFUND (unmatched only)"]},"card":{"type":"string","description":"Credit card number."},"amount":{"type":"string","description":"Total transaction amount."},"id":{"type":"string","description":"Unique identifier for the transaction request."},"billing":{"$ref":"#/components/schemas/Address"},"shipping":{"$ref":"#/components/schemas/Address"},"csc":{"type":"string","description":"Card Security Code (CVV)."},"invoice":{"type":"string","description":"Invoice number for the transaction."},"description":{"type":"string","description":"Description of the transaction"},"comments":{"type":"string","description":"Additional comments related to the transaction."},"software-type":{"type":"string","description":"Type of software initiating the transaction."},"software-type-version":{"type":"string","description":"Version of the software used."},"sales-tax-type":{"type":"string","description":"Type of sales tax.","enum":["LOCAL_SALES_TAX,TAX_EXEMPT"]},"sales-tax-amount":{"type":"string","description":"Amount of sales tax applied."},"service-fee":{"type":"string","description":"Additional service fee."},"signature-base-64-image":{"type":"string","description":"Base64-encoded signature image."},"tip-amount":{"type":"string","description":"Tip amount included in the transaction."},"authorization-code":{"type":"string","description":"Code used to authorize the transaction."},"purchase-order":{"type":"string","description":"Purchase order number."},"email-receipt":{"type":"string","description":"Indicates if a receipt should be emailed."},"email-address":{"type":"string","description":"Email address of the customer."},"customer-id":{"type":"string","description":"Identifier for the customer."},"order-id":{"type":"string","description":"Unique identifier for the order."},"client-ip":{"type":"string","description":"IP address of the client initiating the transaction."},"billing-is-shipping":{"type":"string","description":"Indicates if billing and shipping addresses are the same."},"create-token":{"type":"string","description":"Indicates if a token should be created for future use."},"token-description":{"type":"string","description":"Description for the token if created."},"check-field":{"type":"string","description":"Field to be checked for validation."},"check-field-mid":{"type":"boolean","description":"Validates MID (Merchant ID) field."},"platform-fees":{"type":"array","description":"List of platform fees applied to the transaction.","items":{"$ref":"#/components/schemas/platform-fee"}},"card-inquiry":{"type":"boolean","description":"If true, performs a card inquiry."},"level3":{"$ref":"#/components/schemas/level3"},"secure3d":{"type":"string","description":"3D Secure authentication data."},"secure3d-eci":{"type":"string","description":"Electronic Commerce Indicator for 3D Secure."},"add-tax-to-amount":{"type":"boolean","description":"Indicates whether sales tax should be added to the total amount used for authorization and capture"}},"xml":{"name":"transaction"}},"Address":{"type":"object","properties":{"company":{"type":"string","description":"The company name for the billing address."},"street":{"type":"string","description":"The primary street address."},"street2":{"type":"string","description":"Additional street information. For example, suite."},"city":{"type":"string","description":"The billing city."},"state":{"type":"string","description":"The state of the billing address."},"zip":{"type":"string","description":"The postal code of billing address."},"country":{"type":"string","description":"The country of the billing address."},"phone":{"type":"string","description":"The contact phone number."},"first-name":{"type":"string","description":"First name of the contact."},"last-name":{"type":"string","description":"Last name of the contact."},"from-zip":{"type":"string","description":"The originating ZIP code."}},"description":"Contains billing address and contact details.","xml":{"name":"clearent-address"}},"platform-fee":{"type":"object","properties":{"fee-name":{"type":"string","description":"The name of the fee applied to the transaction.","enum":["DealManager","FillMyBook"]}},"description":"List of platform fees applied.","xml":{"name":"platform-fee"}},"level3":{"type":"object","properties":{"vat-tax-amount":{"type":"string","description":"The VAT amount applied to the transaction."},"vat-tax-rate":{"type":"string","description":"VAT tax rate applied to the transaction."},"order-date":{"type":"string","description":"The date when the order was created."},"customer-vat-registration-number":{"type":"string","description":"Cardholder's VAT registration number."},"summary-commodity-code":{"type":"string","description":"Code that identifies the type of service included in the transaction."},"discount-amount":{"type":"string","description":"Total discount amount."},"destination-country-code":{"type":"string","description":"The ISO country code of the destination."},"freight-amount":{"type":"string","description":"Freight charges."},"duty-amount":{"type":"string","description":"Duty amount applied."},"level3-items":{"$ref":"#/components/schemas/level3-items"}},"description":"Level 3 data for enhanced transaction details.","xml":{"name":"level3"}},"level3-items":{"type":"object","properties":{"level3-items":{"type":"array","items":{"$ref":"#/components/schemas/level3-item"}}},"description":"Level 3 line-item data for the transaction.","xml":{"name":"level3-items"}},"level3-item":{"type":"object","properties":{"item-description":{"type":"string","description":"Description of the item."},"item-commodity-code":{"type":"string","description":"Commodity code of the item."},"item-quantity":{"type":"string","description":"Quantity of items comprising of the order."},"item-unit-of-measure":{"type":"string","description":"The unit of measure of the purchased item as determined by ANSI X-12. Allowable Units of Measure and Codes."},"item-unit-cost":{"type":"string","description":"Per item cost for the order."},"item-product-code":{"type":"string","description":"Merchant identifiable code e.g., SKU or Model Number."},"item-tax-amount":{"type":"string","description":"Tax amount per item."},"item-tax-rate":{"type":"string","description":"Tax rate per item expressed as a decimal."},"item-discount":{"type":"string","description":"Discount amount applied per item."},"item-line-total":{"type":"string","description":"Total item count for the order."},"item-net-gross-ind":{"type":"string","description":"Indicated where the extended item amount is included in the tax. Can either be Yes (\"Y\") or No (\"N\") but should be passed as \"N\"."},"item-discount-rate":{"type":"string","description":"Discount rate applied per item expressed as a decimal."}},"description":"Level 3 line-item data for the transaction.","xml":{"name":"level3-item"}},"ClearentTransactionResponsePayload":{"type":"object","properties":{"transaction":{"$ref":"#/components/schemas/transaction"},"payloadType":{"type":"string","description":"Type of payload returned in the response.","xml":{"name":"type","attribute":true}}},"description":"payload","xml":{"name":"payload"}},"transaction":{"type":"object","properties":{"amount":{"type":"string","description":"Total value associated with the transaction."},"currency":{"type":"string","description":"Currency used for the transaction."},"id":{"type":"string","description":"Unique transaction ID."},"invoice":{"type":"string","description":"Invoice number associated with the transaction."},"description":{"type":"string","description":"Description of the transaction."},"comments":{"type":"string","description":"Comments associated with the transaction."},"serverId":{"type":"string","deprecated":true},"created":{"type":"string","description":"Date and time when the transaction was created."},"type":{"type":"string","description":"Identifies the transaction type.","enum":["AUTH","SALE","REFUND","VOID","CAPTURE","FORCED SALE","CARD INQUIRY"]},"result":{"type":"string","description":"Result of the transaction. For example, APPROVED.","enum":["APPROVED","DECLINED","ERROR"]},"billing":{"$ref":"#/components/schemas/Address"},"shipping":{"$ref":"#/components/schemas/Address"},"card":{"type":"string","description":"Card number used for the transaction."},"csc":{"type":"string","description":"Card Security Code used."},"cvm":{"type":"string","description":"Cardholder Verification Method used.","enum":["NON (None)","MSG(Manual Signature)","OFC(Offline Pin in the Clear)","PIN(Online Pin)","OFE(Offline Encrypted Pin)"]},"action":{"$ref":"#/components/schemas/action"},"authorization-code":{"type":"string","description":"Code indicating the transaction authorization."},"avs-result-code":{"type":"string","description":"Result code from Address Verification Service.","enum":["X","Y","A","W","Z","N","U","R","S","G"]},"avs-result-code-description":{"type":"string","description":"Description of the AVS result."},"csc-result-code":{"type":"string","description":"Result code from CSC verification.","enum":["M","N","P","S","U","X"]},"csc-result-code-description":{"type":"string","description":"Description of the CSC result."},"tip-adjusted-amount":{"type":"string","description":"Amount of the adjusted tip."},"avs-street":{"type":"string","description":"Street used in AVS check."},"avs-zip":{"type":"string","description":"ZIP code used in AVS check."},"token-description":{"type":"string","description":"Description of the token created."},"original-amount":{"type":"string","description":"Original amount before adjustments."},"tip-amount":{"type":"string","description":"Tip amount included in the transaction."},"ref-id":{"type":"string","description":"Reference ID for the transaction."},"entry-method":{"type":"string","description":"Method used to enter payment data of the transaction. For example, Swipe/Manual."},"first-recurring-transaction":{"type":"string","description":"Indicates whether this is the first recurring transaction."},"batch-string-id":{"type":"string","description":"Identifies the settlement batch ID."},"order-id":{"type":"string","description":"Order id passed in with the transaction."},"purchase-order":{"type":"string","description":"Purchase order number."},"customer-id":{"type":"string","description":"Customer id passed in with the transaction."},"email-address":{"type":"string","description":"Email address associated with the transaction."},"display-message":{"type":"string","description":"Displayable message about transaction result."},"result-code":{"type":"string","description":"Result code associated with transaction result."},"billing-is-shipping":{"type":"string","description":"Indicates if billing and shipping addresses are the same."},"tip-adjusted":{"type":"string","description":"Indicates if the tip was adjusted."},"exp-date":{"type":"string","description":"Expiration date of the card."},"client-ip":{"type":"string","description":"IP address of the client initiating the transaction."},"voided":{"type":"string","description":"Indicates if the transaction was voided."},"pending":{"type":"string","description":"Indicates if the transaction is pending."},"voided-auth":{"type":"string","description":"Indicates if the authorization was voided."},"settled":{"type":"string","description":"Indicates if the transaction has been settled."},"status":{"type":"string","description":"Status of the transaction. For example, approved."},"emv-data":{"type":"string","description":"Raw EMV data string."},"key-serial-number":{"type":"string","description":"Serial number of the encryption key used."},"emv-entry-method":{"type":"string","description":"Method used to enter EMV data.","enum":["EMV_DIP","EMV_CONTACTLESS","EMV_FALLBACK_SWIPE","EMV_FALLBACK_NONTECH"]},"software-type":{"type":"string","description":"Type of software used for the transaction."},"customer-first-name":{"type":"string","description":"First name of the customer."},"customer-last-name":{"type":"string","description":"Last name of the customer."},"plan-name":{"type":"string","description":"Name of the payment plan used."},"card-type":{"type":"string","description":"Type of card used. For example, VISA."},"contactless":{"type":"string","description":"Indicates if contactless payment was used."},"contactless-device":{"type":"string","description":"Indicates if a contactless device was used."},"sales-tax-type":{"type":"string","description":"Type of sales tax applied."},"sales-tax-amount":{"type":"string","description":"Amount of sales tax applied."},"add-tax-to-amount":{"type":"boolean","description":"Indicates if tax was added to the transaction amount."},"emv-data-response":{"type":"string","description":"Response data from EMV processing."},"emv":{"$ref":"#/components/schemas/emv"},"signature-base-64-image":{"type":"string","description":"Base64-encoded image of the signature."},"last-four":{"type":"string","description":"Last four digits of the card number."},"check-field-duplicate":{"type":"boolean","description":"Indicates if a duplicate check was performed."},"service-fee":{"type":"string","description":"Service fee applied to the transaction"},"base-amount":{"type":"string","description":"Base amount before taxes and fees."},"platform-fees":{"type":"array","description":"List of platform fees applied.","items":{"$ref":"#/components/schemas/platform-fee"}},"merchant-id":{"type":"string","description":"Identifier for the merchant."},"terminal-id":{"type":"string","description":"Identifier for the terminal used."},"surcharge-applied":{"type":"boolean","description":"Indicates if a surcharge was applied."},"level3":{"$ref":"#/components/schemas/level3"},"partial-authorization":{"type":"boolean","description":"Indicates if partial authorization was allowed."},"partial-approved":{"type":"boolean","description":"Indicates if the transaction was partially approved."},"additional-amounts":{"type":"array","description":"List of additional amounts applied to the transaction.","xml":{"wrapped":true},"items":{"$ref":"#/components/schemas/additional-amount"}},"secure3d-eci":{"type":"string","description":"Electronic Commerce Indicator for 3D Secure."},"secure3d-result-code":{"type":"string","description":"Result code from 3D Secure authentication."},"total-amount":{"type":"string","description":"Total amount including all charges."},"processing-party-reference":{"type":"string","description":"Reference ID from the processing party."},"original-processing-party-reference":{"type":"string","description":"Reference of the original transaction assigned by the processing party."},"external-transaction-reference":{"type":"string","description":"External reference ID for the transaction."},"funding-reference":{"type":"string","description":"Reference for the funding transaction."},"token-id":{"type":"string","description":"Identifier of the payment token."},"network-transaction-reference":{"type":"string","description":"Reference ID from the payment network for the transaction."},"create-token":{"type":"boolean","description":"Indicates if a token should be created for the transaction."},"moto":{"type":"boolean","description":"Indicates whether the transaction is MOTO."},"issuer_id":{"type":"string","description":"Identifier for the card issuer."},"digital-wallet-type":{"type":"string","description":"Type of digital wallet used. For example, GOOGLE."}},"description":"Contains all details related to the authorized transaction.","xml":{"name":"transaction"}},"action":{"type":"object","properties":{"url":{"type":"string","description":"URL endpoint used for the transaction."},"method":{"type":"string","description":"Method used for the transaction. For example, POST, GET."},"type":{"type":"string","description":"Type of transaction. For example, SALE."},"environment":{"type":"string","description":"Environment in which the transaction was processed. For example, production, test."},"locale":{"type":"string","description":"Locale setting used during the transaction."},"data":{"type":"object","additionalProperties":{"type":"string","description":"Additional data properties related to the action."},"description":"Additional data properties related to the action."},"payment-method-type":{"type":"string","description":"Type of payment method used. For example, card, wallet."},"sub-type":{"type":"string","description":"Sub-category of the transaction type."},"client-key":{"type":"string","description":"Key identifying the client initiating the transaction."},"qr-code-data":{"type":"string","description":"Data encoded in the QR code for the transaction."}},"description":"The transaction action performed.","xml":{"name":"action"}},"emv":{"type":"object","properties":{"application-name":{"type":"string","description":"The name of the EMV application used to process the transaction."},"application-id":{"type":"string","description":"The unique identifier of the application."},"terminal-verification-results":{"type":"string","description":"Results of terminal-level verification during the transaction."},"transaction-status-information":{"type":"string","description":"Status details that describes the processing state of the transaction."},"iad":{"type":"string","description":"IAD provided by the card issuer during the authorization."},"transaction-certificate":{"type":"string","description":"A certificate generated during the transaction processing."},"application-transaction-counter":{"type":"string","description":"A counter that increments with each transaction."}},"description":"EMV chip data related to the transaction.","xml":{"name":"emv"}},"additional-amount":{"type":"object","properties":{"amount":{"type":"string","description":"Amount of transaction."},"account-type":{"type":"string","description":"Account type of transaction."},"amount-type":{"type":"string","description":"Refers to amount type of transaction."}},"description":"List of additional amounts applied to the transaction.","xml":{"name":"additional-amount"}},"ErrorResult":{"type":"object","properties":{"errorResults":{"type":"array","items":{"$ref":"#/components/schemas/Error"}}}},"Error":{"type":"object","properties":{"errorMessage":{"type":"string","description":"Describes the reason for the error."},"resultCode":{"type":"integer","description":"Numeric code that identifies the type of error returned by the request.","format":"int32"},"timeStamp":{"type":"string","description":"Date and time when the error occurred, ISO 8601 format (UTC)."}}}}}}
```

## Authorize mobile transaction

> Create an authorization transactions on mobile of $1 or more using a mobile transaction token.

```json
{"openapi":"3.0.1","info":{"title":"Mobile Transactions","version":"2.0"},"paths":{"/rest/v2/mobile/transactions/auth":{"post":{"tags":["Mobile Transactions"],"summary":"Authorize mobile transaction","description":"Create an authorization transactions on mobile of $1 or more using a mobile transaction token.","operationId":"doAuth","parameters":[{"name":"api-key","in":"header","description":"An access API key issued to you by Xplor Pay.","required":true},{"name":"mobilejwt","in":"header","description":"The transaction token returned from the successfulTransactionToken method of the Mobile framework.","required":true}],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ClearentGatewayRequest"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ClearentGatewayRequest"}}},"required":true},"responses":{"200":{"description":"Successful Transaction","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ClearentTransactionResponsePayload"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ClearentTransactionResponsePayload"}}}},"400":{"description":"Bad Request","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResult"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorResult"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResult"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorResult"}}}},"402":{"description":"Business Exception (decline, etc.) ","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResult"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorResult"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResult"}},"application/xml":{"schema":{"$ref":"#/components/schemas/ErrorResult"}}}}}}}},"components":{"schemas":{"ClearentGatewayRequest":{"required":["amount","software-type","software-type-version","type"],"type":"object","properties":{"type":{"type":"string","description":"Type of transaction.","enum":["AUTH,SALE,FORCED SALE,REFUND (unmatched only)"]},"card":{"type":"string","description":"Credit card number."},"amount":{"type":"string","description":"Total transaction amount."},"id":{"type":"string","description":"Unique identifier for the transaction request."},"billing":{"$ref":"#/components/schemas/Address"},"shipping":{"$ref":"#/components/schemas/Address"},"csc":{"type":"string","description":"Card Security Code (CVV)."},"invoice":{"type":"string","description":"Invoice number for the transaction."},"description":{"type":"string","description":"Description of the transaction"},"comments":{"type":"string","description":"Additional comments related to the transaction."},"software-type":{"type":"string","description":"Type of software initiating the transaction."},"software-type-version":{"type":"string","description":"Version of the software used."},"sales-tax-type":{"type":"string","description":"Type of sales tax.","enum":["LOCAL_SALES_TAX,TAX_EXEMPT"]},"sales-tax-amount":{"type":"string","description":"Amount of sales tax applied."},"service-fee":{"type":"string","description":"Additional service fee."},"signature-base-64-image":{"type":"string","description":"Base64-encoded signature image."},"tip-amount":{"type":"string","description":"Tip amount included in the transaction."},"authorization-code":{"type":"string","description":"Code used to authorize the transaction."},"purchase-order":{"type":"string","description":"Purchase order number."},"email-receipt":{"type":"string","description":"Indicates if a receipt should be emailed."},"email-address":{"type":"string","description":"Email address of the customer."},"customer-id":{"type":"string","description":"Identifier for the customer."},"order-id":{"type":"string","description":"Unique identifier for the order."},"client-ip":{"type":"string","description":"IP address of the client initiating the transaction."},"billing-is-shipping":{"type":"string","description":"Indicates if billing and shipping addresses are the same."},"create-token":{"type":"string","description":"Indicates if a token should be created for future use."},"token-description":{"type":"string","description":"Description for the token if created."},"check-field":{"type":"string","description":"Field to be checked for validation."},"check-field-mid":{"type":"boolean","description":"Validates MID (Merchant ID) field."},"platform-fees":{"type":"array","description":"List of platform fees applied to the transaction.","items":{"$ref":"#/components/schemas/platform-fee"}},"card-inquiry":{"type":"boolean","description":"If true, performs a card inquiry."},"level3":{"$ref":"#/components/schemas/level3"},"secure3d":{"type":"string","description":"3D Secure authentication data."},"secure3d-eci":{"type":"string","description":"Electronic Commerce Indicator for 3D Secure."},"add-tax-to-amount":{"type":"boolean","description":"Indicates whether sales tax should be added to the total amount used for authorization and capture"}},"xml":{"name":"transaction"}},"Address":{"type":"object","properties":{"company":{"type":"string","description":"The company name for the billing address."},"street":{"type":"string","description":"The primary street address."},"street2":{"type":"string","description":"Additional street information. For example, suite."},"city":{"type":"string","description":"The billing city."},"state":{"type":"string","description":"The state of the billing address."},"zip":{"type":"string","description":"The postal code of billing address."},"country":{"type":"string","description":"The country of the billing address."},"phone":{"type":"string","description":"The contact phone number."},"first-name":{"type":"string","description":"First name of the contact."},"last-name":{"type":"string","description":"Last name of the contact."},"from-zip":{"type":"string","description":"The originating ZIP code."}},"description":"Contains billing address and contact details.","xml":{"name":"clearent-address"}},"platform-fee":{"type":"object","properties":{"fee-name":{"type":"string","description":"The name of the fee applied to the transaction.","enum":["DealManager","FillMyBook"]}},"description":"List of platform fees applied.","xml":{"name":"platform-fee"}},"level3":{"type":"object","properties":{"vat-tax-amount":{"type":"string","description":"The VAT amount applied to the transaction."},"vat-tax-rate":{"type":"string","description":"VAT tax rate applied to the transaction."},"order-date":{"type":"string","description":"The date when the order was created."},"customer-vat-registration-number":{"type":"string","description":"Cardholder's VAT registration number."},"summary-commodity-code":{"type":"string","description":"Code that identifies the type of service included in the transaction."},"discount-amount":{"type":"string","description":"Total discount amount."},"destination-country-code":{"type":"string","description":"The ISO country code of the destination."},"freight-amount":{"type":"string","description":"Freight charges."},"duty-amount":{"type":"string","description":"Duty amount applied."},"level3-items":{"$ref":"#/components/schemas/level3-items"}},"description":"Level 3 data for enhanced transaction details.","xml":{"name":"level3"}},"level3-items":{"type":"object","properties":{"level3-items":{"type":"array","items":{"$ref":"#/components/schemas/level3-item"}}},"description":"Level 3 line-item data for the transaction.","xml":{"name":"level3-items"}},"level3-item":{"type":"object","properties":{"item-description":{"type":"string","description":"Description of the item."},"item-commodity-code":{"type":"string","description":"Commodity code of the item."},"item-quantity":{"type":"string","description":"Quantity of items comprising of the order."},"item-unit-of-measure":{"type":"string","description":"The unit of measure of the purchased item as determined by ANSI X-12. Allowable Units of Measure and Codes."},"item-unit-cost":{"type":"string","description":"Per item cost for the order."},"item-product-code":{"type":"string","description":"Merchant identifiable code e.g., SKU or Model Number."},"item-tax-amount":{"type":"string","description":"Tax amount per item."},"item-tax-rate":{"type":"string","description":"Tax rate per item expressed as a decimal."},"item-discount":{"type":"string","description":"Discount amount applied per item."},"item-line-total":{"type":"string","description":"Total item count for the order."},"item-net-gross-ind":{"type":"string","description":"Indicated where the extended item amount is included in the tax. Can either be Yes (\"Y\") or No (\"N\") but should be passed as \"N\"."},"item-discount-rate":{"type":"string","description":"Discount rate applied per item expressed as a decimal."}},"description":"Level 3 line-item data for the transaction.","xml":{"name":"level3-item"}},"ClearentTransactionResponsePayload":{"type":"object","properties":{"transaction":{"$ref":"#/components/schemas/transaction"},"payloadType":{"type":"string","description":"Type of payload returned in the response.","xml":{"name":"type","attribute":true}}},"description":"payload","xml":{"name":"payload"}},"transaction":{"type":"object","properties":{"amount":{"type":"string","description":"Total value associated with the transaction."},"currency":{"type":"string","description":"Currency used for the transaction."},"id":{"type":"string","description":"Unique transaction ID."},"invoice":{"type":"string","description":"Invoice number associated with the transaction."},"description":{"type":"string","description":"Description of the transaction."},"comments":{"type":"string","description":"Comments associated with the transaction."},"serverId":{"type":"string","deprecated":true},"created":{"type":"string","description":"Date and time when the transaction was created."},"type":{"type":"string","description":"Identifies the transaction type.","enum":["AUTH","SALE","REFUND","VOID","CAPTURE","FORCED SALE","CARD INQUIRY"]},"result":{"type":"string","description":"Result of the transaction. For example, APPROVED.","enum":["APPROVED","DECLINED","ERROR"]},"billing":{"$ref":"#/components/schemas/Address"},"shipping":{"$ref":"#/components/schemas/Address"},"card":{"type":"string","description":"Card number used for the transaction."},"csc":{"type":"string","description":"Card Security Code used."},"cvm":{"type":"string","description":"Cardholder Verification Method used.","enum":["NON (None)","MSG(Manual Signature)","OFC(Offline Pin in the Clear)","PIN(Online Pin)","OFE(Offline Encrypted Pin)"]},"action":{"$ref":"#/components/schemas/action"},"authorization-code":{"type":"string","description":"Code indicating the transaction authorization."},"avs-result-code":{"type":"string","description":"Result code from Address Verification Service.","enum":["X","Y","A","W","Z","N","U","R","S","G"]},"avs-result-code-description":{"type":"string","description":"Description of the AVS result."},"csc-result-code":{"type":"string","description":"Result code from CSC verification.","enum":["M","N","P","S","U","X"]},"csc-result-code-description":{"type":"string","description":"Description of the CSC result."},"tip-adjusted-amount":{"type":"string","description":"Amount of the adjusted tip."},"avs-street":{"type":"string","description":"Street used in AVS check."},"avs-zip":{"type":"string","description":"ZIP code used in AVS check."},"token-description":{"type":"string","description":"Description of the token created."},"original-amount":{"type":"string","description":"Original amount before adjustments."},"tip-amount":{"type":"string","description":"Tip amount included in the transaction."},"ref-id":{"type":"string","description":"Reference ID for the transaction."},"entry-method":{"type":"string","description":"Method used to enter payment data of the transaction. For example, Swipe/Manual."},"first-recurring-transaction":{"type":"string","description":"Indicates whether this is the first recurring transaction."},"batch-string-id":{"type":"string","description":"Identifies the settlement batch ID."},"order-id":{"type":"string","description":"Order id passed in with the transaction."},"purchase-order":{"type":"string","description":"Purchase order number."},"customer-id":{"type":"string","description":"Customer id passed in with the transaction."},"email-address":{"type":"string","description":"Email address associated with the transaction."},"display-message":{"type":"string","description":"Displayable message about transaction result."},"result-code":{"type":"string","description":"Result code associated with transaction result."},"billing-is-shipping":{"type":"string","description":"Indicates if billing and shipping addresses are the same."},"tip-adjusted":{"type":"string","description":"Indicates if the tip was adjusted."},"exp-date":{"type":"string","description":"Expiration date of the card."},"client-ip":{"type":"string","description":"IP address of the client initiating the transaction."},"voided":{"type":"string","description":"Indicates if the transaction was voided."},"pending":{"type":"string","description":"Indicates if the transaction is pending."},"voided-auth":{"type":"string","description":"Indicates if the authorization was voided."},"settled":{"type":"string","description":"Indicates if the transaction has been settled."},"status":{"type":"string","description":"Status of the transaction. For example, approved."},"emv-data":{"type":"string","description":"Raw EMV data string."},"key-serial-number":{"type":"string","description":"Serial number of the encryption key used."},"emv-entry-method":{"type":"string","description":"Method used to enter EMV data.","enum":["EMV_DIP","EMV_CONTACTLESS","EMV_FALLBACK_SWIPE","EMV_FALLBACK_NONTECH"]},"software-type":{"type":"string","description":"Type of software used for the transaction."},"customer-first-name":{"type":"string","description":"First name of the customer."},"customer-last-name":{"type":"string","description":"Last name of the customer."},"plan-name":{"type":"string","description":"Name of the payment plan used."},"card-type":{"type":"string","description":"Type of card used. For example, VISA."},"contactless":{"type":"string","description":"Indicates if contactless payment was used."},"contactless-device":{"type":"string","description":"Indicates if a contactless device was used."},"sales-tax-type":{"type":"string","description":"Type of sales tax applied."},"sales-tax-amount":{"type":"string","description":"Amount of sales tax applied."},"add-tax-to-amount":{"type":"boolean","description":"Indicates if tax was added to the transaction amount."},"emv-data-response":{"type":"string","description":"Response data from EMV processing."},"emv":{"$ref":"#/components/schemas/emv"},"signature-base-64-image":{"type":"string","description":"Base64-encoded image of the signature."},"last-four":{"type":"string","description":"Last four digits of the card number."},"check-field-duplicate":{"type":"boolean","description":"Indicates if a duplicate check was performed."},"service-fee":{"type":"string","description":"Service fee applied to the transaction"},"base-amount":{"type":"string","description":"Base amount before taxes and fees."},"platform-fees":{"type":"array","description":"List of platform fees applied.","items":{"$ref":"#/components/schemas/platform-fee"}},"merchant-id":{"type":"string","description":"Identifier for the merchant."},"terminal-id":{"type":"string","description":"Identifier for the terminal used."},"surcharge-applied":{"type":"boolean","description":"Indicates if a surcharge was applied."},"level3":{"$ref":"#/components/schemas/level3"},"partial-authorization":{"type":"boolean","description":"Indicates if partial authorization was allowed."},"partial-approved":{"type":"boolean","description":"Indicates if the transaction was partially approved."},"additional-amounts":{"type":"array","description":"List of additional amounts applied to the transaction.","xml":{"wrapped":true},"items":{"$ref":"#/components/schemas/additional-amount"}},"secure3d-eci":{"type":"string","description":"Electronic Commerce Indicator for 3D Secure."},"secure3d-result-code":{"type":"string","description":"Result code from 3D Secure authentication."},"total-amount":{"type":"string","description":"Total amount including all charges."},"processing-party-reference":{"type":"string","description":"Reference ID from the processing party."},"original-processing-party-reference":{"type":"string","description":"Reference of the original transaction assigned by the processing party."},"external-transaction-reference":{"type":"string","description":"External reference ID for the transaction."},"funding-reference":{"type":"string","description":"Reference for the funding transaction."},"token-id":{"type":"string","description":"Identifier of the payment token."},"network-transaction-reference":{"type":"string","description":"Reference ID from the payment network for the transaction."},"create-token":{"type":"boolean","description":"Indicates if a token should be created for the transaction."},"moto":{"type":"boolean","description":"Indicates whether the transaction is MOTO."},"issuer_id":{"type":"string","description":"Identifier for the card issuer."},"digital-wallet-type":{"type":"string","description":"Type of digital wallet used. For example, GOOGLE."}},"description":"Contains all details related to the authorized transaction.","xml":{"name":"transaction"}},"action":{"type":"object","properties":{"url":{"type":"string","description":"URL endpoint used for the transaction."},"method":{"type":"string","description":"Method used for the transaction. For example, POST, GET."},"type":{"type":"string","description":"Type of transaction. For example, SALE."},"environment":{"type":"string","description":"Environment in which the transaction was processed. For example, production, test."},"locale":{"type":"string","description":"Locale setting used during the transaction."},"data":{"type":"object","additionalProperties":{"type":"string","description":"Additional data properties related to the action."},"description":"Additional data properties related to the action."},"payment-method-type":{"type":"string","description":"Type of payment method used. For example, card, wallet."},"sub-type":{"type":"string","description":"Sub-category of the transaction type."},"client-key":{"type":"string","description":"Key identifying the client initiating the transaction."},"qr-code-data":{"type":"string","description":"Data encoded in the QR code for the transaction."}},"description":"The transaction action performed.","xml":{"name":"action"}},"emv":{"type":"object","properties":{"application-name":{"type":"string","description":"The name of the EMV application used to process the transaction."},"application-id":{"type":"string","description":"The unique identifier of the application."},"terminal-verification-results":{"type":"string","description":"Results of terminal-level verification during the transaction."},"transaction-status-information":{"type":"string","description":"Status details that describes the processing state of the transaction."},"iad":{"type":"string","description":"IAD provided by the card issuer during the authorization."},"transaction-certificate":{"type":"string","description":"A certificate generated during the transaction processing."},"application-transaction-counter":{"type":"string","description":"A counter that increments with each transaction."}},"description":"EMV chip data related to the transaction.","xml":{"name":"emv"}},"additional-amount":{"type":"object","properties":{"amount":{"type":"string","description":"Amount of transaction."},"account-type":{"type":"string","description":"Account type of transaction."},"amount-type":{"type":"string","description":"Refers to amount type of transaction."}},"description":"List of additional amounts applied to the transaction.","xml":{"name":"additional-amount"}},"ErrorResult":{"type":"object","properties":{"errorResults":{"type":"array","items":{"$ref":"#/components/schemas/Error"}}}},"Error":{"type":"object","properties":{"errorMessage":{"type":"string","description":"Describes the reason for the error."},"resultCode":{"type":"integer","description":"Numeric code that identifies the type of error returned by the request.","format":"int32"},"timeStamp":{"type":"string","description":"Date and time when the error occurred, ISO 8601 format (UTC)."}}}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.xplorpay.com/api-reference/api/payments/mobile/mobile-payment-transactions/mobile-transactions.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
